CON
  _CLKMODE      = XTAL1 + PLL16X
  _XINFREQ      = 5_000_000

'===========< IO Pin assignments >==========
  EncdrLA        = 8  'Left Wheel Encoder Phase A
  EncdrLB        = 9  'Left Wheel Encoder Phase B
  EncdrRA        = 10  'Right Wheel Encoder Phase A
  EncdrRB        = 11 'Right Wheel Encoder Phase B
  Mask           = |<EncdrLA  + |<EncdrLB + |<EncdrRA + |<EncdrRB

'========< Counter mode values >=========
  ModeNegEdge   = %01110 << 26          'Negative Edge Detector for wheel encoders
  ModeNCO       = %00100 << 26          'Bit 31 overflow goes to pin for servo drives

PUB Start
'  Left wheel counter
    Frqa := 1
    Phsa := 0
    Ctra := ModeNegEdge + EncdrLA
' Right Wheel counter
    Frqb := 1
    Phsb := 0
    Ctrb := ModeNegEdge + EncdrRA

PUB CZero                             
    Phsa := 0
    Phsb := 0

PUB RCount
   return Phsb

PUB LCount
   Return Phsa
   