{{         ---------   Polygon  ----------
     Draw a polygon of Sides Sides. and size Size using the Stingray
                      By Ray Tracy
}}

CON
  _CLKMODE      = XTAL1 + PLL16X
  _XINFREQ      = 5_000_000

  Clock         = 80_000_000        'CLKFREQ
  ms1           = Clock / 1_000
  
' ============= < Encoder Constants > ==============
' Linxmotion QME-01 Rotary encoder 100 pulses per rev, 30:1 gearmotor
' yields 3000 Encoder pulses (Ep) per tire revolution
  EpPerRev             = 3000
  Epmm                 = EpPerRev / WheelCircumferenceMM     'Encoder Pulses per Millimeter (7.67)
  Epcm                 = Epmm * 10                           'Encoder Pulses per centimeter
  Epdeg                = TurnCircumferenceMM * Epmm / 360    'Ep per Degree (17.12)
  
'============< Stingray Measurements > ===========
  WheelDiameterMM      = 123        'Millimeters, By Actual Measurement 
  WheelCircumferenceMM = 391        'Millimeters, By Actual Measurement 
  WheelbaseMM          = 256        'Millimeters, By Actual Measurement
  TurnCircumferenceMM  = 804        'Millimeters  
  Slow                 = 30
  Sides                = 6
  Size                 = 75         'Centimeters
  
OBJ
  Drv: "MyMotorDriver"   ' See Obex motorEngine by Kwabena W. Agyeman
  Ctr: "MyEncoder"
    
PUB Main
   Drv.Start
   Ctr.Start
   Repeat Sides
      DrvCm(Size, "F", Slow)
      Stop
      Pause(1000)
      Turn(360/Sides, "R", Slow)
      Stop
      Pause(1000)
   repeat
      Stop

Pri Turn(Degrees, Direction, Speed)| Ep
   Ep := EpDeg * Degrees        
   Ctr.Czero              'Clear the counter 
   case Direction
      "R": Right(Speed)
      "L": Left(Speed)
   Repeat
   until (Phsa => Ep)                        
  
Pri DrvCm(Distance, Direction, Speed) | Ep
   Ep := Epcm * Distance
   case Direction
       "F": Forward(Speed)
       "R": Reverse(Speed)
   Ctr.Czero
   Repeat
   until (Phsa => Ep)
   
Pri Pause(msecs)
   waitcnt(msecs*ms1+cnt)
           
Pri Forward(Speed)
  Drv.SetMotorA(Speed)          'A Left
  Drv.SetMotorB(Speed)          'B Right
   
Pri Reverse(Speed)
  Drv.SetMotorA(-Speed)         'A Left
  Drv.SetMotorB(-Speed)         'B Right
  
Pri Right(Speed)
   Drv.SetMotorA( Speed)       'A Left  Fwd
   Drv.SetMotorB(-Speed)       'B Right Rev

Pri Left(Speed)
   Drv.SetMotorA(-Speed)       'A Left  Rev
   Drv.SetMotorB( Speed)       'B Right Fwd

Pri Stop
  Drv.SetMotorA(1)             'A Left
  Drv.SetMotorB(1)             'B Right
  